Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LBC/mppini.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LBC/mppini.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LBC/mppini.F90	(revision 14644)
@@ -47,5 +47,5 @@
 CONTAINS
 
-#if ! defined key_mpp_mpi
+#if defined key_mpi_off
    !!----------------------------------------------------------------------
    !!   Default option :                            shared memory computing
@@ -69,8 +69,5 @@
       jpi    = jpiglo
       jpj    = jpjglo
-      jpk    = jpkglo
-      jpim1  = jpi-1                         ! inner domain indices
-      jpjm1  = jpj-1                         !   "           "
-      jpkm1  = MAX( 1, jpk-1 )               !   "           "
+      jpk    = MAX( 2, jpkglo )
       jpij   = jpi*jpj
       jpni   = 1
@@ -79,12 +76,5 @@
       nimpp  = 1
       njmpp  = 1
-      nbondi = 2
-      nbondj = 2
       nidom  = FLIO_DOM_NONE
-      npolj = 0
-      IF( jperio == 3 .OR. jperio == 4 )   npolj = 3
-      IF( jperio == 5 .OR. jperio == 6 )   npolj = 5
-      l_Iperio = jpni == 1 .AND. (jperio == 1 .OR. jperio == 4 .OR. jperio == 6 .OR. jperio == 7)
-      l_Jperio = jpnj == 1 .AND. (jperio == 2 .OR. jperio == 7)
       !
       CALL init_doloop                       ! set start/end indices or do-loop depending on the halo width value (nn_hls)
@@ -95,5 +85,5 @@
          WRITE(numout,*) '~~~~~~~~ '
          WRITE(numout,*) '   l_Iperio = ', l_Iperio, '    l_Jperio = ', l_Jperio
-         WRITE(numout,*) '     npolj  = ',   npolj , '      njmpp  = ', njmpp
+         WRITE(numout,*) '     njmpp  = ', njmpp
       ENDIF
       !
@@ -107,5 +97,5 @@
 #else
    !!----------------------------------------------------------------------
-   !!   'key_mpp_mpi'                     MPI massively parallel processing
+   !!                   MPI massively parallel processing
    !!----------------------------------------------------------------------
 
@@ -123,7 +113,5 @@
       !! ** Method  :   Global domain is distributed in smaller local domains.
       !!      Periodic condition is a function of the local domain position
-      !!      (global boundary or neighbouring domain) and of the global
-      !!      periodic
-      !!      Type :         jperio global periodic condition
+      !!      (global boundary or neighbouring domain) and of the global periodic
       !!
       !! ** Action : - set domain parameters
@@ -131,33 +119,25 @@
       !!                    njmpp     : latitudinal  index
       !!                    narea     : number for local area
-      !!                    nbondi    : mark for "east-west local boundary"
-      !!                    nbondj    : mark for "north-south local boundary"
-      !!                    nproc     : number for local processor
-      !!                    noea      : number for local neighboring processor
-      !!                    nowe      : number for local neighboring processor
-      !!                    noso      : number for local neighboring processor
-      !!                    nono      : number for local neighboring processor
-      !!----------------------------------------------------------------------
-      INTEGER ::   ji, jj, jn, jproc, jarea   ! dummy loop indices
-      INTEGER ::   inijmin
-      INTEGER ::   inum                       ! local logical unit
-      INTEGER ::   idir, ifreq                ! local integers
-      INTEGER ::   ii, il1, ili, imil         !   -       -
-      INTEGER ::   ij, il2, ilj, ijm1         !   -       -
-      INTEGER ::   iino, ijno, iiso, ijso     !   -       -
-      INTEGER ::   iiea, ijea, iiwe, ijwe     !   -       -
-      INTEGER ::   iarea0                     !   -       -
-      INTEGER ::   ierr, ios                  !
-      INTEGER ::   inbi, inbj, iimax,  ijmax, icnt1, icnt2
+      !!                    mpinei    : number of neighboring domains (starting at 0, -1 if no neighbourg)
+      !!----------------------------------------------------------------------
+      INTEGER ::   ji, jj, jn, jp, jh
+      INTEGER ::   ii, ij, ii2, ij2
+      INTEGER ::   inijmin   ! number of oce subdomains
+      INTEGER ::   inum, inum0
+      INTEGER ::   ifreq, il1, imil, il2, ijm1
+      INTEGER ::   ierr, ios
+      INTEGER ::   inbi, inbj, iimax, ijmax, icnt1, icnt2
+      INTEGER, DIMENSION(16*n_hlsmax) :: ichanged
+      INTEGER, ALLOCATABLE, DIMENSION(:    ) ::   iin, ijn
+      INTEGER, ALLOCATABLE, DIMENSION(:,:  ) ::   iimppt, ijpi, ipproc
+      INTEGER, ALLOCATABLE, DIMENSION(:,:  ) ::   ijmppt, ijpj
+      INTEGER, ALLOCATABLE, DIMENSION(:,:  ) ::   impi
+      INTEGER, ALLOCATABLE, DIMENSION(:,:,:) ::   inei
       LOGICAL ::   llbest, llauto
       LOGICAL ::   llwrtlay
+      LOGICAL ::   llmpi_Iperio, llmpi_Jperio, llmpiNFold
       LOGICAL ::   ln_listonly
-      INTEGER, ALLOCATABLE, DIMENSION(:)     ::   iin, ii_nono, ii_noea          ! 1D workspace
-      INTEGER, ALLOCATABLE, DIMENSION(:)     ::   ijn, ii_noso, ii_nowe          !  -     -
-      INTEGER, ALLOCATABLE, DIMENSION(:,:) ::   iimppt, ijpi, ibondi, ipproc   ! 2D workspace
-      INTEGER, ALLOCATABLE, DIMENSION(:,:) ::   ijmppt, ijpj, ibondj, ipolj    !  -     -
-      INTEGER, ALLOCATABLE, DIMENSION(:,:) ::   iie0, iis0, iono, ioea         !  -     -
-      INTEGER, ALLOCATABLE, DIMENSION(:,:) ::   ije0, ijs0, ioso, iowe         !  -     -
-      LOGICAL, ALLOCATABLE, DIMENSION(:,:) ::   llisoce                        !  -     -
+      LOGICAL, ALLOCATABLE, DIMENSION(:,:  ) ::   llisOce  ! is not land-domain only?
+      LOGICAL, ALLOCATABLE, DIMENSION(:,:,:) ::   llnei    ! are neighbourgs existing?
       NAMELIST/nambdy/ ln_bdy, nb_bdy, ln_coords_file, cn_coords_file,           &
            &             ln_mask_file, cn_mask_file, cn_dyn2d, nn_dyn2d_dta,     &
@@ -166,5 +146,5 @@
            &             cn_ice, nn_ice_dta,                                     &
            &             ln_vol, nn_volctl, nn_rimwidth
-      NAMELIST/nammpp/ jpni, jpnj, nn_hls, ln_nnogather, ln_listonly
+      NAMELIST/nammpp/ jpni, jpnj, nn_hls, ln_nnogather, ln_listonly, nn_comm
       !!----------------------------------------------------------------------
       !
@@ -194,7 +174,4 @@
       IF(lwm)   WRITE( numond, nammpp )
       !
-!!!------------------------------------
-!!!  nn_hls shloud be read in nammpp
-!!!------------------------------------
       jpiglo = Ni0glo + 2 * nn_hls
       jpjglo = Nj0glo + 2 * nn_hls
@@ -214,5 +191,5 @@
       ! -----------------------------------
       !
-      ! If dimensions of processors grid weren't specified in the namelist file
+      ! If dimensions of MPI processes grid weren't specified in the namelist file
       ! then we calculate them here now that we have our communicator size
       IF(lwp) THEN
@@ -261,7 +238,7 @@
 
       ! look for land mpi subdomains...
-      ALLOCATE( llisoce(jpni,jpnj) )
-      CALL mpp_is_ocean( llisoce )
-      inijmin = COUNT( llisoce )   ! number of oce subdomains
+      ALLOCATE( llisOce(jpni,jpnj) )
+      CALL mpp_is_ocean( llisOce )
+      inijmin = COUNT( llisOce )   ! number of oce subdomains
 
       IF( mppsize < inijmin ) THEN   ! too many oce subdomains: can happen only if jpni and jpnj are prescribed...
@@ -320,15 +297,10 @@
 9003  FORMAT (a, i5)
 
-      ALLOCATE(  nfimpp(jpni ) , nfproc(jpni ) ,   nfjpi(jpni ) ,                     &
-         &       nimppt(jpnij) , ibonit(jpnij) ,  jpiall(jpnij) ,  jpjall(jpnij) ,    &
-         &       njmppt(jpnij) , ibonjt(jpnij) , nis0all(jpnij) , njs0all(jpnij) ,    &
-         &                                       nie0all(jpnij) , nje0all(jpnij) ,    &
-         &       iin(jpnij), ii_nono(jpnij), ii_noea(jpnij),   &
-         &       ijn(jpnij), ii_noso(jpnij), ii_nowe(jpnij),   &
-         &       iimppt(jpni,jpnj), ijpi(jpni,jpnj), ibondi(jpni,jpnj), ipproc(jpni,jpnj),   &
-         &       ijmppt(jpni,jpnj), ijpj(jpni,jpnj), ibondj(jpni,jpnj),  ipolj(jpni,jpnj),   &
-         &         iie0(jpni,jpnj), iis0(jpni,jpnj),   iono(jpni,jpnj),   ioea(jpni,jpnj),   &
-         &         ije0(jpni,jpnj), ijs0(jpni,jpnj),   ioso(jpni,jpnj),   iowe(jpni,jpnj),   &
-         &       STAT=ierr )
+      ALLOCATE( nfimpp(jpni), nfproc(jpni), nfjpi(jpni),   &
+         &      iin(jpnij), ijn(jpnij),   &
+         &      iimppt(jpni,jpnj), ijmppt(jpni,jpnj), ijpi(jpni,jpnj), ijpj(jpni,jpnj), ipproc(jpni,jpnj),   &
+         &      inei(8,jpni,jpnj), llnei(8,jpni,jpnj),   &
+         &      impi(8,jpnij),   &
+         &      STAT=ierr )
       CALL mpp_sum( 'mppini', ierr )
       IF( ierr /= 0 )   CALL ctl_stop( 'STOP', 'mpp_init: unable to allocate standard ocean arrays' )
@@ -344,17 +316,16 @@
       !
       CALL mpp_basesplit( jpiglo, jpjglo, nn_hls, jpni, jpnj, jpimax, jpjmax, iimppt, ijmppt, ijpi, ijpj )
-      CALL mpp_getnum( llisoce, ipproc, iin, ijn )
-      !
-      !DO jn = 1, jpni
-      !   jproc = ipproc(jn,jpnj)
-      !   ii = iin(jproc+1)
-      !   ij = ijn(jproc+1)
-      !   nfproc(jn) = jproc
-      !   nfimpp(jn) = iimppt(ii,ij)
-      !   nfjpi (jn) =   ijpi(ii,ij)
-      !END DO
-      nfproc(:) = ipproc(:,jpnj)
-      nfimpp(:) = iimppt(:,jpnj)
-      nfjpi (:) =   ijpi(:,jpnj)
+      CALL mpp_getnum( llisOce, ipproc, iin, ijn )
+      !
+      ii = iin(narea)
+      ij = ijn(narea)
+      jpi   = ijpi(ii,ij)
+      jpj   = ijpj(ii,ij)
+      jpk   = MAX( 2, jpkglo )
+      jpij  = jpi*jpj
+      nimpp = iimppt(ii,ij)
+      njmpp = ijmppt(ii,ij)
+      !
+      CALL init_doloop                          ! set start/end indices of do-loop, depending on the halo width value (nn_hls)
       !
       IF(lwp) THEN
@@ -366,120 +337,11 @@
          WRITE(numout,*) '      jpnj = ', jpnj
          WRITE(numout,*) '     jpnij = ', jpnij
+         WRITE(numout,*) '     nimpp = ', nimpp
+         WRITE(numout,*) '     njmpp = ', njmpp
          WRITE(numout,*)
          WRITE(numout,*) '      sum ijpi(i,1) = ', sum(ijpi(:,1)), ' jpiglo = ', jpiglo
-         WRITE(numout,*) '      sum ijpj(1,j) = ', sum(ijpj(1,:)), ' jpjglo = ', jpjglo
-      ENDIF
-
-      ! 3. Subdomain description in the Regular Case
-      ! --------------------------------------------
-      ! specific cases where there is no communication -> must do the periodicity by itself
-      ! Warning: because of potential land-area suppression, do not use nbond[ij] == 2
-      l_Iperio = jpni == 1 .AND. (jperio == 1 .OR. jperio == 4 .OR. jperio == 6 .OR. jperio == 7)
-      l_Jperio = jpnj == 1 .AND. (jperio == 2 .OR. jperio == 7)
-
-      DO jarea = 1, jpni*jpnj
-         !
-         iarea0 = jarea - 1
-         ii = 1 + MOD(iarea0,jpni)
-         ij = 1 +     iarea0/jpni
-         ili = ijpi(ii,ij)
-         ilj = ijpj(ii,ij)
-         ibondi(ii,ij) = 0                         ! default: has e-w neighbours
-         IF( ii   ==    1 )   ibondi(ii,ij) = -1   ! first column, has only e neighbour
-         IF( ii   == jpni )   ibondi(ii,ij) =  1   ! last column,  has only w neighbour
-         IF( jpni ==    1 )   ibondi(ii,ij) =  2   ! has no e-w neighbour
-         ibondj(ii,ij) = 0                         ! default: has n-s neighbours
-         IF( ij   ==    1 )   ibondj(ii,ij) = -1   ! first row, has only n neighbour
-         IF( ij   == jpnj )   ibondj(ii,ij) =  1   ! last row,  has only s neighbour
-         IF( jpnj ==    1 )   ibondj(ii,ij) =  2   ! has no n-s neighbour
-
-         ! Subdomain neighbors (get their zone number): default definition
-         ioso(ii,ij) = iarea0 - jpni
-         iowe(ii,ij) = iarea0 - 1
-         ioea(ii,ij) = iarea0 + 1
-         iono(ii,ij) = iarea0 + jpni
-         iis0(ii,ij) =  1  + nn_hls
-         iie0(ii,ij) = ili - nn_hls
-         ijs0(ii,ij) =  1  + nn_hls
-         ije0(ii,ij) = ilj - nn_hls
-
-         ! East-West periodicity: change ibondi, ioea, iowe
-         IF( jperio == 1 .OR. jperio == 4 .OR. jperio == 6 .OR. jperio == 7 ) THEN
-            IF( jpni  /= 1 )   ibondi(ii,ij) = 0                        ! redefine: all have e-w neighbours
-            IF( ii ==    1 )   iowe(ii,ij) = iarea0 +        (jpni-1)   ! redefine: first column, address of w neighbour
-            IF( ii == jpni )   ioea(ii,ij) = iarea0 -        (jpni-1)   ! redefine: last column,  address of e neighbour
-         ENDIF
-
-         ! Simple North-South periodicity: change ibondj, ioso, iono
-         IF( jperio == 2 .OR. jperio == 7 ) THEN
-            IF( jpnj  /= 1 )   ibondj(ii,ij) = 0                        ! redefine: all have n-s neighbours
-            IF( ij ==    1 )   ioso(ii,ij) = iarea0 + jpni * (jpnj-1)   ! redefine: first row, address of s neighbour
-            IF( ij == jpnj )   iono(ii,ij) = iarea0 - jpni * (jpnj-1)   ! redefine: last row,  address of n neighbour
-         ENDIF
-
-         ! North fold: define ipolj, change iono. Warning: we do not change ibondj...
-         ipolj(ii,ij) = 0
-         IF( jperio == 3 .OR. jperio == 4 ) THEN
-            ijm1 = jpni*(jpnj-1)
-            imil = ijm1+(jpni+1)/2
-            IF( jarea > ijm1 ) ipolj(ii,ij) = 3
-            IF( MOD(jpni,2) == 1 .AND. jarea == imil ) ipolj(ii,ij) = 4
-            IF( ipolj(ii,ij) == 3 ) iono(ii,ij) = jpni*jpnj-jarea+ijm1   ! MPI rank of northern neighbour
-         ENDIF
-         IF( jperio == 5 .OR. jperio == 6 ) THEN
-            ijm1 = jpni*(jpnj-1)
-            imil = ijm1+(jpni+1)/2
-            IF( jarea > ijm1) ipolj(ii,ij) = 5
-            IF( MOD(jpni,2) == 1 .AND. jarea == imil ) ipolj(ii,ij) = 6
-            IF( ipolj(ii,ij) == 5) iono(ii,ij) = jpni*jpnj-jarea+ijm1    ! MPI rank of northern neighbour
-         ENDIF
-         !
-      END DO
-
-      ! 4. deal with land subdomains
-      ! ----------------------------
-      !
-      ! neighbour treatment: change ibondi, ibondj if next to a land zone
-      DO jarea = 1, jpni*jpnj
-         ii = 1 + MOD( jarea-1  , jpni )
-         ij = 1 +     (jarea-1) / jpni
-         ! land-only area with an active n neigbour
-         IF ( ipproc(ii,ij) == -1 .AND. 0 <= iono(ii,ij) .AND. iono(ii,ij) <= jpni*jpnj-1 ) THEN
-            iino = 1 + MOD( iono(ii,ij) , jpni )                    ! ii index of this n neigbour
-            ijno = 1 +      iono(ii,ij) / jpni                      ! ij index of this n neigbour
-            ! In case of north fold exchange: I am the n neigbour of my n neigbour!! (#1057)
-            ! --> for northern neighbours of northern row processors (in case of north-fold)
-            !     need to reverse the LOGICAL direction of communication
-            idir = 1                                           ! we are indeed the s neigbour of this n neigbour
-            IF( ij == jpnj .AND. ijno == jpnj )   idir = -1    ! both are on the last row, we are in fact the n neigbour
-            IF( ibondj(iino,ijno) == idir     )   ibondj(iino,ijno) =   2     ! this n neigbour had only a s/n neigbour -> no more
-            IF( ibondj(iino,ijno) == 0        )   ibondj(iino,ijno) = -idir   ! this n neigbour had both, n-s neighbours -> keep 1
-         ENDIF
-         ! land-only area with an active s neigbour
-         IF( ipproc(ii,ij) == -1 .AND. 0 <= ioso(ii,ij) .AND. ioso(ii,ij) <= jpni*jpnj-1 ) THEN
-            iiso = 1 + MOD( ioso(ii,ij) , jpni )                    ! ii index of this s neigbour
-            ijso = 1 +      ioso(ii,ij) / jpni                      ! ij index of this s neigbour
-            IF( ibondj(iiso,ijso) == -1 )   ibondj(iiso,ijso) = 2   ! this s neigbour had only a n neigbour    -> no more neigbour
-            IF( ibondj(iiso,ijso) ==  0 )   ibondj(iiso,ijso) = 1   ! this s neigbour had both, n-s neighbours -> keep s neigbour
-         ENDIF
-         ! land-only area with an active e neigbour
-         IF( ipproc(ii,ij) == -1 .AND. 0 <= ioea(ii,ij) .AND. ioea(ii,ij) <= jpni*jpnj-1 ) THEN
-            iiea = 1 + MOD( ioea(ii,ij) , jpni )                    ! ii index of this e neigbour
-            ijea = 1 +      ioea(ii,ij) / jpni                      ! ij index of this e neigbour
-            IF( ibondi(iiea,ijea) == 1 )   ibondi(iiea,ijea) =  2   ! this e neigbour had only a w neigbour    -> no more neigbour
-            IF( ibondi(iiea,ijea) == 0 )   ibondi(iiea,ijea) = -1   ! this e neigbour had both, e-w neighbours -> keep e neigbour
-         ENDIF
-         ! land-only area with an active w neigbour
-         IF( ipproc(ii,ij) == -1 .AND. 0 <= iowe(ii,ij) .AND. iowe(ii,ij) <= jpni*jpnj-1) THEN
-            iiwe = 1 + MOD( iowe(ii,ij) , jpni )                    ! ii index of this w neigbour
-            ijwe = 1 +      iowe(ii,ij) / jpni                      ! ij index of this w neigbour
-            IF( ibondi(iiwe,ijwe) == -1 )   ibondi(iiwe,ijwe) = 2   ! this w neigbour had only a e neigbour    -> no more neigbour
-            IF( ibondi(iiwe,ijwe) ==  0 )   ibondi(iiwe,ijwe) = 1   ! this w neigbour had both, e-w neighbours -> keep w neigbour
-         ENDIF
-      END DO
-
-      ! 5. Subdomain print
-      ! ------------------
-      IF(lwp) THEN
+         WRITE(numout,*) '      sum ijpj(1,j) = ', SUM(ijpj(1,:)), ' jpjglo = ', jpjglo
+         
+         ! Subdomain grid print
          ifreq = 4
          il1 = 1
